# Class ListProperty<E>

java.lang.Object
javafx.beans.binding.ListExpression<E>
javafx.beans.property.ReadOnlyListProperty<E>
javafx.beans.property.ListProperty<E>

Type Parameters:
  `E` - the type of the `List` elements

All Implemented Interfaces:
  `Iterable<E>, Collection<E>, List<E>, SequencedCollection<E>, Observable, Property<ObservableList<E>>, ReadOnlyProperty<ObservableList<E>>, ObservableListValue<E>, ObservableObjectValue<ObservableList<E>>, ObservableValue<ObservableList<E>>, WritableListValue<E>, WritableObjectValue<ObservableList<E>>, WritableValue<ObservableList<E>>, ObservableList<E>`

Direct Known Subclasses:
  `ListPropertyBase`

public abstract class ListProperty<E> extends ReadOnlyListProperty<E> implements Property<ObservableList<E>>, WritableListValue<E>
This class provides a full implementation of a `Property` wrapping an `ObservableList`. The value of a `ListProperty` can be get and set with `ObservableObjectValue.get()`, `ListExpression.getValue()`, `WritableObjectValue.set(Object)`, and `setValue(ObservableList)`. A property can be bound and unbound unidirectional with `Property.bind(javafx.beans.value.ObservableValue)` and `Property.unbind()`. Bidirectional bindings can be created and removed with `bindBidirectional(Property)` and `unbindBidirectional(Property)`. The context of a `ListProperty` can be read with `ReadOnlyProperty.getBean()` and `ReadOnlyProperty.getName()`.

Since:
  JavaFX 2.1
See Also:
  - `ObservableList`
  - `ObservableListValue`
  - `WritableListValue`
  - `ReadOnlyListProperty`
  - `Property`

- ## Property Summary

  ### Properties declared in class ListExpression

  `empty, size`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `ListProperty()`
  Creates a default `ListProperty`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `bindBidirectional(Property<ObservableList<E>> other)`
  Create a bidirectional binding between this `Property` and another one.
  `void`
  `setValue(ObservableList<E> v)`
  Set the wrapped value.
  `String`
  `toString()`
  Returns a string representation of this `ListProperty` object.
  `void`
  `unbindBidirectional(Property<ObservableList<E>> other)`
  Removes a bidirectional binding between this `Property` and another one.

  ### Methods declared in class ReadOnlyListProperty

  `bindContent, bindContentBidirectional, equals, hashCode, unbindContent, unbindContentBidirectional`

  ### Methods declared in class ListExpression

  `add, add, addAll, addAll, addAll, asString, clear, contains, containsAll, emptyProperty, get, getSize, getValue, indexOf, isEmpty, isEqualTo, isNotEqualTo, isNotNull, isNull, iterator, lastIndexOf, listExpression, listIterator, listIterator, remove, remove, remove, removeAll, removeAll, retainAll, retainAll, set, setAll, setAll, size, sizeProperty, subList, toArray, toArray, valueAt, valueAt`

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

  ### Methods declared in interface Collection

  `parallelStream, removeIf, stream, toArray`

  ### Methods declared in interface Iterable

  `forEach`

  ### Methods declared in interface List

  `add, add, addAll, addAll, addFirst, addLast, clear, contains, containsAll, equals, get, getFirst, getLast, hashCode, indexOf, isEmpty, iterator, lastIndexOf, listIterator, listIterator, remove, remove, removeAll, removeFirst, removeLast, replaceAll, retainAll, reversed, set, size, sort, spliterator, subList, toArray, toArray`

  ### Methods declared in interface Observable

  `addListener, removeListener, subscribe`

  ### Methods declared in interface ObservableList

  `addAll, addListener, filtered, remove, removeAll, removeListener, replaceRange, retainAll, setAll, setAll, sorted, sorted`

  ### Methods declared in interface ObservableObjectValue

  `get`

  ### Methods declared in interface ObservableValue

  `addListener, flatMap, getValue, map, orElse, removeListener, subscribe, subscribe, when`

  ### Methods declared in interface Property

  `bind, isBound, unbind`

  ### Methods declared in interface ReadOnlyProperty

  `getBean, getName`

  ### Methods declared in interface WritableObjectValue

  `get, set`

  ### Methods declared in interface WritableValue

  `getValue`

- ## Constructor Details

  - ### ListProperty

    public ListProperty()
    Creates a default `ListProperty`.

- ## Method Details

  - ### setValue

    public void setValue(ObservableList<E> v)
    Set the wrapped value.
    Specified by:
      `setValue` in interface `WritableValue<E>`
    Parameters:
      `v` - The new value

  - ### bindBidirectional

    public void bindBidirectional(Property<ObservableList<E>> other)
    Create a bidirectional binding between this `Property` and another one. Bidirectional bindings exists independently of unidirectional bindings. So it is possible to add unidirectional binding to a property with bidirectional binding and vice-versa. However, this practice is discouraged.

    It is possible to have multiple bidirectional bindings of one Property.

    JavaFX bidirectional binding implementation use weak listeners. This means bidirectional binding does not prevent properties from being garbage collected.

    Specified by:
      `bindBidirectional` in interface `Property<E>`
    Parameters:
      `other` - the other `Property`

  - ### unbindBidirectional

    public void unbindBidirectional(Property<ObservableList<E>> other)
    Removes a bidirectional binding between this `Property` and another one. If no bidirectional binding between the properties exists, calling this method has no effect. It is possible to unbind by a call on the second property. This code will work:

    >         property1.bindBidirectional(property2);
    >         property2.unbindBidirectional(property1);

    Specified by:
      `unbindBidirectional` in interface `Property<E>`
    Parameters:
      `other` - the other `Property`

  - ### toString

    public String toString()
    Returns a string representation of this `ListProperty` object.
    Overrides:
      `toString` in class `ReadOnlyListProperty<E>`
    Returns:
      a string representation of this `ListProperty` object.